package org.belot.client;

import org.belot.server.*;
import java.util.*;

public class CardsComparator implements Comparator {

  private BelotColor trump;

  public void setTrump(BelotColor trump) {
    this.trump = trump;
  }

  private static BelotColor[] orderSpades = new BelotColor[] {
    BelotColor.Diamonds, BelotColor.Clubs, BelotColor.Hearts, BelotColor.Spades
  };

  private static BelotColor[] orderHearts = new BelotColor[] {
    BelotColor.Spades, BelotColor.Diamonds, BelotColor.Clubs, BelotColor.Hearts
  };

  private static BelotColor[] orderClubs = new BelotColor[] {
    BelotColor.Hearts, BelotColor.Spades, BelotColor.Diamonds, BelotColor.Clubs
  };

  private static BelotColor[] orderDiamonds = new BelotColor[] {
    BelotColor.Clubs, BelotColor.Hearts, BelotColor.Spades, BelotColor.Diamonds
  };

  public int compare(Object x, Object y) {
    return -compare0(x, y);
  }

  private int compare0(Object x, Object y) {
    if (x == y) {
      return 0;
    }
    if (x == null) {
      return 1;
    }
    if (y == null) {
      return -1;
    }
    BelotCard a = (BelotCard)x;
    BelotCard b = (BelotCard)y;
    if (a.getColor() == b.getColor()) {
      return a.compareTo(b.getNumber(), trump);
    } else {
      BelotColor[] order = orderSpades;
      if (trump == BelotColor.Hearts) {
        order = orderHearts;
      } else if (trump == BelotColor.Clubs) {
        order = orderClubs;
      } else if (trump == BelotColor.Diamonds) {
        order = orderDiamonds;
      }
      int indexA = findColor(a.getColor(), order);
      int indexB = findColor(b.getColor(), order);
      return indexA - indexB;
    }
  }

  private static int findColor(BelotColor color, BelotColor[] order) {
    for (int i = 0; i < order.length; ++i) {
      if (color == order[i]) {
        return i;
      }
    }
    return -1;
  }

}