package org.belot.client.board;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import org.belot.protocol.*;
import org.belot.server.*;

import java.io.*;
import java.util.*;
import java.net.*;

import org.belot.client.*;
import org.belot.client.images.*;

public abstract class CardsPanel extends JPanel {

  protected static final int INSETS = 5;

  protected JLabel[] labelsByPosition = new JLabel[] {
    new JLabel(),
    new JLabel(),
    new JLabel(),
    new JLabel(),
    new JLabel(),
    new JLabel(),
    new JLabel(),
    new JLabel(),
  };
  protected ImageIcon[] imagesByPosition = new ImageIcon[8];
  protected CardsImages cardsImages;
  protected Insets insets = new Insets(INSETS, INSETS, INSETS, INSETS);
  protected BelotClient belotClient;

  public CardsPanel(CardsImages cardsImages, BelotClient belotClient) {
    super(new GridBagLayout());

    this.cardsImages = cardsImages;
    this.belotClient = belotClient;

//    this.setBackground(Color.white);
//
    for (int i = 0; i < 8; ++i) {
      HandPanel.setLabelSizes(labelsByPosition[i]);
      labelsByPosition[i].setVisible(false);
      this.add(labelsByPosition[i], new GridBagConstraints(i, 0, 1, 1, 0.0, 0.0,
        GridBagConstraints.CENTER, GridBagConstraints.NONE, insets, 0, 0));
    }
  }

  public Dimension getPreferredSize() {
    return new Dimension(
      CardsImages.CARD_WIDTH * 8 + 16 * INSETS,
      CardsImages.CARD_HEIGHT + 2 * INSETS
    );
  }

  public abstract void loadCards(BelotCard[] handOfCards);
  public abstract void clearSelection();
  public abstract BelotCard getSelectedValue();

  public static void main(String[] arg) {
    CardsImages cardsImages = new CardsImages();
    CardsPanel cardsPanel = new CardsPanelImpl(cardsImages, null);
    JFrame frame = new JFrame();
    JScrollPane scrollPane = new JScrollPane(cardsPanel);
    frame.getContentPane().add(scrollPane);
    Dimension size = new Dimension(800, 600);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((screenSize.width - size.width) / 2, (screenSize.height - size.height) / 2);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setSize(size);
    cardsPanel.loadCards(new BelotCard[] {
      new BelotCard(0, 11),
      new BelotCard(1, 12),
      new BelotCard(2, 13),
      new BelotCard(3, 14),

      new BelotCard(3, 14),
      new BelotCard(3, 14),
      new BelotCard(3, 14),
      new BelotCard(3, 14),
    });
    frame.setVisible(true);
  }

}