package org.belot.client.board;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import org.belot.protocol.*;
import org.belot.server.*;

import java.io.*;
import java.util.*;
import java.net.*;

import org.belot.client.*;
import org.belot.client.images.*;

public class CardsPanelImpl extends CardsPanel {

  private int selectedCard = -1;
  private BelotCard[] objects = new BelotCard[8];

  public CardsPanelImpl(CardsImages cardsImages, BelotClient belotClient) {
    super(cardsImages, belotClient);
    Listener listener = new Listener();
    addMouseListener(listener);
    for (int i = 0; i < labelsByPosition.length; ++i) {
      labelsByPosition[i].addMouseListener(listener);
    }
  }

  public void loadCards(BelotCard[] cards) {
    this.objects = cards;
    for (int i = 0; i < 8; ++i) {
      ImageIcon newImage;
      if (i < cards.length) {
        newImage = cardsImages.getImage(cards[i]);
      } else {
        newImage = null;
      }
      if (imagesByPosition[i] != newImage) {
        imagesByPosition[i] = newImage;
        if (newImage == null) {
          labelsByPosition[i].setVisible(false);
          labelsByPosition[i].setIcon(null);
        } else {
          labelsByPosition[i].setIcon(newImage);
          labelsByPosition[i].setVisible(true);
        }
      }
    }
  }

  public BelotCard getSelectedValue() {
    if (selectedCard == -1 || this.objects == null || selectedCard >= this.objects.length) {
      return null;
    }
    return this.objects[selectedCard];
  }

  public void clearSelection() {
    selectedCard = -1;
  }

  private class Listener extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      Object source = e.getSource();
      selectedCard = -1;
      for (int i = 0; i < labelsByPosition.length; ++i) {
        if (labelsByPosition[i] == source) {
          selectedCard = i;
          break;
        }
      }
      belotClient.showPopupMenu((JComponent)e.getSource(), e.getX(), e.getY());
      e.consume();
    }
  }

}