package org.belot.client.board;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import org.belot.protocol.*;
import org.belot.server.*;

import java.io.*;
import java.util.*;
import java.net.*;

import org.belot.client.*;
import org.belot.client.images.*;

public class HandPanelImpl extends HandPanel {

  public HandPanelImpl(CardsImages cardsImages, BelotClient belotClient) {
    super(cardsImages, belotClient);
    Listener listener = new Listener();
    addMouseListener(listener);
    for (int i = 0; i < labelsByPosition.length; ++i) {
      labelsByPosition[i].addMouseListener(listener);
    }
  }

  public static int getIndex(int i, int playerPosition, int firstHandPlayer) {
    return (i + (4 - firstHandPlayer) + (4 - (SOUTH - playerPosition))) % 4;
  }

  public void loadCards(BelotCard[] handOfCards, int playerPosition, int firstHandPlayer) {
//    boolean change = false;
    for (int i = 0; i < 4; ++i) {
      int index = getIndex(i, playerPosition, firstHandPlayer);
      ImageIcon newImage = cardsImages.getImage(handOfCards[index]);
      if (newImage == null) {
        newImage = cardsImages.getBack();
      }
      if (newImage != imagesByPosition[i]) {
        imagesByPosition[i] = newImage;
        labelsByPosition[i].setIcon(newImage);
        setLabelSizes(labelsByPosition[i]);
//        change = true;
      }
    }
//    if (change) {
//      revalidate();
//      repaint();
//    }
  }

  private class Listener extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      belotClient.showPopupMenu((JComponent)e.getSource(), e.getX(), e.getY());
      e.consume();
    }
  }

}