package org.belot.server;

import java.util.Vector;

public interface BelotGame {

  // Team 0 is Player 0 + Player 2
  // Team 1 is Player 1 + Player 3

  public static final int FirstTeam = 0;
  public static final int SecondTeam = 1;

  public static final int MAX_TEAM_SCORE = 151;

  // Game:
  public void startGame();
  public boolean isGameFinished();
  public int getTeamScore(int team);
  public int getHanging();

  // Dealing:
  public void startDealing();
  public boolean isDealingFinished();
  public int[] calculateDealingScore();
  public boolean getLastWasNoCardsTaken();

  // Betting:
  public int getPlayerBettingTurn();
  public boolean canBet(BelotColor color, boolean contra);
  public void bet(BelotColor color, boolean contra);
  public void finishBetting();

  // Trump:
  public BelotColor getTrump();
  public boolean isContra();
  public boolean isReContra();

  // Announcing:
  public boolean canAnnounce(int what, int card);
  public void announce(int what, int card);

  // Playing:
  public int getPlayerPlayingTurn();
  public boolean canPlay(int card);
  public void play(int card);

  // Cards:
  public BelotCard[] getPlayerCards(int player);
  public BelotCard[] getHandOfCards();

}