package org.belot.server;

import java.net.*;
import org.belot.protocol.*;

public class BelotServer {

  public void run() {
    try {
      BelotGame belotGame = new BelotGameImpl();
      GameManager gameManager = new GameManagerImpl(belotGame);
      PlayerManager playerManager = new PlayerManager();
      GlobalDispatcher globalDispatcher = new GlobalDispatcher();
      ClientWorker clientWorker = new ClientWorker(
        playerManager, gameManager, globalDispatcher);
      ServerSocket belotServerSocket = new ServerSocket(BelotProtocol.BelotPort);
      for (;;) {
        boolean accept = playerManager.size() < 1000;
        if (accept) {
          Socket socket = belotServerSocket.accept();
          socket.setKeepAlive(true);
          socket.setTcpNoDelay(true);
          new ClientCommandThread(clientWorker, globalDispatcher, socket);
        } else {
          try {
            Thread.sleep(1);
          } catch (InterruptedException intex) {
            intex.printStackTrace();
          }
        }
      }
    } catch (Throwable error) {

    }
  }

  public static void main(String[] arg) {
    new BelotServer().run();
  }

}