package org.belot.server;

import org.belot.protocol.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class ClientSenderThread implements Runnable {

  private Vector messages;
  private OutputStream out;

  public ClientSenderThread(OutputStream out) {
    synchronized (this) {
      this.messages = new Vector();
      this.out = new BufferedOutputStream(out, 200);
      new Thread(this).start();
    }
  }

  public synchronized void depositMessage(String message) {
    if (this.messages != null) {
      this.messages.addElement(message);
      notifyAll();
    }
  }

  public synchronized void closeClientSenderThread() {
    this.messages = null;
    notifyAll();
  }

  public void run() {
    try {
      OutputStream out;
      synchronized (this) {
        out = this.out;
      }
      for (;;) {
        String message = null;
        synchronized (this) {
          if (messages.size() > 0) {
            message = (String)messages.elementAt(0);
            messages.removeElementAt(0);
          }
        }
        if (message != null) {
          out.write(message.getBytes("UTF8"));
          out.write('\r');
          out.write('\n');
          out.flush();
        } else {
          synchronized (this) {
            try {
              wait();
            } catch (Exception intex) {
              intex.printStackTrace(System.out);
            }
          }
        }
      }
    } catch (Throwable error) {
      // do nothing.
    }
  }

}