package org.belot.server;

public interface GameManager {

  public static final int NO_GAME = 0;
  public static final int NO_DEALING = 1;
  public static final int BETTING = 2;
  public static final int PLAYING = 3;

  public int getStage();

  // always:
  public int[] getTeamScores();
  public int[] getDealingScores();
  public PreviousHand getCurrentHand();

  // only in NO_GAME:
  public void startGame();

  // only in NO_DEALING:
  public void startDealing();

  // only in BETTING:
  public void bet(int player, BelotColor color, boolean contra);
  public int getBettingDirection();

  // only in BETTING and PLAYING:
  public BelotColor getBet();
  public boolean isContra();
  public boolean isReContra();
  public int getBettingPlayer();
  public BelotCard[] getPlayerCards(int player);

  // only in PLAYING:
  public void play(int player, int index);
  public void playBelot(int player, int index);
  public void announce(int player, int what, int index);
  public int getPlayingDirection();

  // only in NO_GAME and NO_DEALING and PLAYING:
//  public boolean isHandFinished();
  // this will return a meaningful result only if the above isHandFinished() returns true:
  public int getHandWinner();

}