package org.belot.server;

import org.belot.protocol.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class GlobalDispatcher {

  private Vector clientSenderThreads;

  public GlobalDispatcher() {
    synchronized (this) {
      this.clientSenderThreads = new Vector();
    }
  }

  public synchronized void addClientSenderThread(ClientSenderThread clientSenderThread) {
    this.clientSenderThreads.addElement(clientSenderThread);
  }

  public synchronized void removeClientSenderThread(ClientSenderThread clientSenderThread) {
    this.clientSenderThreads.removeElement(clientSenderThread);
  }

  public synchronized void broadcast(String message) {
    int size = this.clientSenderThreads.size();
    for (int i = 0; i < size; ++i) {
      ((ClientSenderThread)this.clientSenderThreads.elementAt(i)).depositMessage(message);
    }
  }

}