package org.belot.server;

import java.util.*;

public class HeapSort {

  // Copied directly from:
  // Ammeraal, L. (1996) Algorithms and Data Structures in C++, Chichester: John Wiley

  public static void sift(Vector a, int k, int n, Comparator comparator) {
    int i, j;
    Object x;
    i = k;
    x = a.elementAt(i);
    while ((j = 2 * i + 1) < n) {
      if (j < n - 1 && comparator.compare(a.elementAt(j), a.elementAt(j + 1)) < 0) {
        j++;
      }
      if (comparator.compare(x, a.elementAt(j)) >= 0) {
        break;
      }
      a.setElementAt(a.elementAt(j), i);
      i = j;
    }
    a.setElementAt(x, i);
  }

  public static void heapSort(Vector a, Comparator comparator) {
    int n = a.size();
    Object x;
    for (int k = n / 2 - 1; k >= 0; k--) {
      sift(a, k, n, comparator);
    }
    while (--n > 0) {
      x = a.elementAt(0);
      a.setElementAt(a.elementAt(n), 0);
      a.setElementAt(x, n);
      sift(a, 0, n, comparator);
    }
  }

}