package org.belot.server;

public class PreviousHand {

  private int firstPlayer;
  private BelotCard[] cards;

  public PreviousHand() {
    synchronized (this) {
      this.cards = new BelotCard[4];
    }
  }

  public synchronized void add(BelotCard card, int player) {
    for (int i = 0; i < 4; ++i) {
      if (cards[i] == null) {
        if (i == 0) {
          firstPlayer = player;
        }
        cards[i] = card;
        return;
      }
    }
    for (int i = 0; i < 4; ++i) {
      cards[i] = null;
    }
    cards[0] = card;
    firstPlayer = player;
  }

  public synchronized BelotCard[] getCards() {
    return cards;
  }

  public synchronized int getFirstPlayer() {
    return firstPlayer;
  }

  public synchronized String toString() {
    return ("[" + cards[0] + ", " + cards[1] + ", " + cards[2] + ", " + cards[3] + "]");
  }

}